]> code.citadel.org Git - citadel.git/blobdiff - citadel/debian/citadel.init
* more debian build added.
[citadel.git] / citadel / debian / citadel.init
index 1d0d8b385185466e7d66bebb1f2d8c2cf119f245..40610d8f6172014b30d28ca63eeef5e8b318dd85 100644 (file)
@@ -1,30 +1,21 @@
-#! /bin/sh
+#!/bin/sh
 ### BEGIN INIT INFO
-# Provides:          skeleton
+# Provides:          citadel-server
 # Required-Start:    $local_fs $remote_fs
 # Required-Stop:     $local_fs $remote_fs
 # Default-Start:     2 3 4 5
 # Default-Stop:      0 1 6
-# Short-Description: Example initscript
-# Description:       This file should be used to construct scripts to be
-#                    placed in /etc/init.d.
+# Short-Description: control citadel server start at boot time
+# Description:       control citadel server start at boot time
 ### END INIT INFO
 
-# Author: Foo Bar <foobar@baz.org>
-#
-# Please remove the "Author" lines above and replace them
-# with your own name if you copy and modify this script.
-
-# Do NOT "set -e"
-
-# PATH should only include /usr/* if it runs after the mountnfs.sh script
+# Author: Wilfried Goesgens <citadel@outgesourced.org>
 RUNDIR=/var/run/citadel
 PATH=/sbin:/usr/sbin:/bin:/usr/bin
 DESC="Citadel Groupware "
 NAME=citserver
 DAEMON=/usr/sbin/$NAME
-CTDLSVC=/usr/lib/citadel-server/ctdlsvc
-DAEMON_ARGS=" -x3 -lmail -t/dev/null"
+DAEMON_ARGS=" -d -x3 -lmail -t/dev/null"
 PIDFILE=$RUNDIR/$NAME.pid
 SCRIPTNAME=/etc/init.d/citadel
 SENDCOMMAND=/usr/sbin/sendcommand
@@ -36,12 +27,20 @@ SENDCOMMAND=/usr/sbin/sendcommand
 # Read configuration variable file if it is present
 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
 
-# Load the VERBOSE setting and other rcS variables
-. /lib/init/vars.sh
+# check if we 've got a newer system, so we can do fancy colors and so on.
+MODERN=
 
+# Load the VERBOSE setting and other rcS variables
+if test -f /lib/init/vars.sh ; then
+    . /lib/init/vars.sh
+    MODERN=1
+fi
 # Define LSB log_* functions.
 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
-. /lib/lsb/init-functions
+if test -f /lib/lsb/init-functions; then
+    . /lib/lsb/init-functions
+    MODERN=1
+fi
 
 #
 # Function that starts the daemon/service
@@ -56,15 +55,12 @@ do_start()
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
-       if $CTDLSVC $PIDFILE $DAEMON \
+       if $DAEMON \
                $DAEMON_ARGS ; then
            return 0
        else
            return 2
        fi
-       # Add code here, if necessary, that waits for the process to be ready
-       # to handle requests from services started subsequently which depend
-       # on this one.  As a last resort, sleep for some time.
 }
 
 #
@@ -79,42 +75,23 @@ do_stop()
        #   other if a failure occurred
         if $SENDCOMMAND "DOWN" >/dev/null 2>&1 ; then
            rm -f $PIDFILE
-           return 0
+
+           while test -S /var/run/citadel/citadel.socket; do 
+               sleep 1
+               echo -n "."
+           done
+               return 0
        else
            rm -f $PIDFILE
            return 2
        fi
 
-       #while test -d /proc/`cat $PIDFILE`; do
-       #    /usr/bin/printf  '.'
-       #    /bin/sleep 1
-       #done
-       #start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
-       #RETVAL="$?"
-       #[ "$RETVAL" = 2 ] && return 2
-       # Wait for children to finish too if this is a daemon that forks
-       # and if the daemon is only ever run from this initscript.
-       # If the above conditions are not satisfied then add some other code
-       # that waits for the process to drop all resources that could be
-       # needed by services started subsequently.  A last resort is to
-       # sleep for some time.
-       #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
-       #[ "$?" = 2 ] && return 2
-       # Many daemons don't delete their pidfiles when they exit.
-       # rm -f $PIDFILE
 }
 
 #
 # Function that sends a SIGHUP to the daemon/service
 #
 do_reload() {
-       #
-       # If the daemon can reload its configuration without
-       # restarting (for example, when it is sent a SIGHUP),
-       # then implement that here.
-       #
-#      start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
         do_stop
         do_start
        return 0
@@ -122,57 +99,66 @@ do_reload() {
 
 case "$1" in
   start)
-       [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+       if test -n "$MODERN"; then
+           [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+       else
+           echo "Starting $DESC" "$NAME"
+       fi
+
        do_start
-       case "$?" in
+       if test -n "$MODERN"; then
+           case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-       esac
+           esac
+       fi
        ;;
   stop)
-       [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+       if test -n "$MODERN"; then
+           [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+       else
+           echo "Stopping $DESC" "$NAME"
+       fi
        do_stop
-       case "$?" in
+       if test -n "$MODERN"; then
+           case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-       esac
+           esac
+       fi
        ;;
-  #reload|force-reload)
-       #
-       # If do_reload() is not implemented then leave this commented out
-       # and leave 'force-reload' as an alias for 'restart'.
-       #
-       #log_daemon_msg "Reloading $DESC" "$NAME"
-       #do_reload
-       #log_end_msg $?
-       #;;
   restart|force-reload)
-       #
-       # If the "reload" option is implemented then remove the
-       # 'force-reload' alias
-       #
-       log_daemon_msg "Restarting $DESC" "$NAME"
+       if test -n "$MODERN"; then
+           log_daemon_msg "Restarting $DESC" "$NAME"
+       else
+           echo "Restarting $DESC" "$NAME"
+       fi
+
        do_stop
-       case "$?" in
-         0|1)
-               do_start
-               case "$?" in
+
+       if test -n "$MODERN"; then
+           case "$?" in
+               0|1)
+                   do_start
+                   case "$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
-               esac
-               ;;
-         *)
+                   esac
+                   ;;
+               *)
                # Failed to stop
-               log_end_msg 1
-               ;;
-       esac
+                   log_end_msg 1
+                   ;;
+           esac
+       else
+           do_start
+       fi
        ;;
   *)
-       #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
-       echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
+       echo "Usage: $SCRIPTNAME {start|stop|restart}" >&2
        exit 3
        ;;
 esac
 
-:
+exit 0
\ No newline at end of file